#include <stdio.h>
#include <math.h>
FILE *fp;
char head[72][80];
char b[512*512*2];
int  i,nn,n1,n2,m1,m2,mm,k=0;

bal(a,b)
short a[],b[];
{
  int j;
  float w1,w2,sigma;  
  shrink1(a,b,1536,2560,1792,2048);
  white_(b,1024,256,&w1,&sigma); 
  shrink1(a,b,1536,2560,2048,2304);
  white_(b,1024,256,&w2,&sigma); 
  return((w1+w2));
}

main(ac,av)
int ac; char *av[];
{
  char *a;
  int ipos; 
  float f64,white;
  if(ac<2){
    printf("\n\n\t *** output /u/ccdev/flati2 (for last?.jpg) ***\n");
    printf("\n\t Ex:   p_flati2 in(d*FLAT*.fit)     2006,10\n\n");
    exit(0);
  }
  fp=fopen(av[1],"rb");
  fread(head,72,80,fp);
  sscanf(&head[3][20],"%d",&n1);
  sscanf(&head[4][20],"%d",&n2);
  ipos=indexpos(head,"BZERO   ",72);
  sscanf(&head[ipos][20],"%f",&f64);
  if(n1>n2)n1=n2; if(n2>n1)n2=n1; 
  m1=m2=512; mm=(n1-1)/m1+1; 
  nn=mm*m1*mm*m1*2;
  a=(char *)malloc(nn);
  fread(a,1,nn,fp);
  fclose(fp);
  swap2(a,nn); 
  de_f64(a,f64,n1,n2);
  fp=fopen("/u/ccdev/flati2","wb");
  fwrite(a,1,nn,fp);
  white=bal(a,b);	 
  printf("center ADU: %f\n",white);
  fwrite(&white,1,4,fp);	    
  fclose(fp);
  free(a);
}

de_f64(a,f64,n1,n2)
short a[];
int n1,n2;
float f64;
{
  int i,j,k;
  j=f64;
  for(i=0;i<n1*n2;i++){
    k=j+a[i]; 
    a[i]=k>>1;
    if(a[i]<1)a[i]=1;
  }    
}

shrink1(b,bb,i1,i2,j1,j2)
short b[4096][4096],bb[1024*256];
int i1,i2,j1,j2;
{
  int i,j,k=0;
  for(i=i1;i<i2;i++)for(j=j1;j<j2;j++)bb[k++]=b[i][j];
}

white_(map,n1,n2,peak,sigma)
short map[];
int n1,n2;
float *peak,*sigma;
{
  int *ihist;
  ihist=(int*)malloc(32767*4);
  white_1(map,n1,n2,peak,sigma,ihist);
  free(ihist);
}

white_1(map,n1,n2,xpeak,sigma,ihist)
short map[]; int n1,n2;
float *xpeak, *sigma;
long  ihist[];
{
  int i,ii;
  int imax=0;
  for(i=0;i<32767;i++)ihist[i]=0;
  for(i=0;i<n1*n2;i++){
    ii=map[i];
    ii+=101;
    if(ii<0 || ii >= 32767)continue;
    ihist[ii]++;
    if(ii>imax)imax=ii;
  }
  histt(ihist,xpeak,sigma,imax);
  *xpeak-=100.0;
}

histt(ihist,xpeak,fsigma,n)
long ihist[];
float *xpeak,*fsigma;
int   n;
{
  int ihtot=0, ihsum=0, iwid=0, maxh=0, mode=0;
  int i,ii,j,jj,k,m,nn, isigm, nfilt, noff, ixpeak, ilow, ihih,ilim,icount;
  float xpar[101],buf[201];
  float xmean=0., xmed=0, sigmsq=0., xcount=0;
  float rttpi, conv, xx, temp, xp,fs,gs,cogd,cogn,cog,xnumb,sd;

  rttpi=2.506628275;
  for(i=1;i<=n;i++){
    nn=n+1-i;
    if(ihist[nn]!=0)break;
  }
  for(i=1;i<=nn;i++)ihtot+=ihist[i];
  for(i=1;i<=nn;i++){
    ihsum+=ihist[i];
    if(ihsum < 0.1*ihtot || ihsum > 0.9*ihtot)continue;
    if(ihist[i] <= maxh)continue;
    maxh=ihist[i];
    mode=i;
  }
  for(i=1;i<=nn;i++){
    temp=ihist[i];
    xcount+=temp;
    xmean+=temp*i;
    sigmsq+=temp*i*i;
  }
  for(i=1;i<=nn;i++){
    xmed+=ihist[i];
   if(xmed > 0.5*xcount){ xmed=i; break; }
  }
  xmean/=xcount;
  gs=xcount/(maxh*rttpi);
  if(gs > 0.1*nn)gs=0.1*nn;
  isigm=gs+0.5;
  if(isigm<3)isigm=3;
  if(isigm>50)isigm=50;
  nfilt=isigm*4+1;
  noff=(nfilt+1)/2;
  conv=0.5/(float)(isigm*isigm);
  for(i=1;i<=noff;i++){
    xx=i-noff;
    buf[i]=exp(-conv*xx*xx);
    buf[nfilt+1-i]=buf[i];
  }
  xp=mode;
  for(k=1;k<=2;k++){
    ixpeak=xp+0.5;
    if(ixpeak > nn)ixpeak=nn;
    if(ixpeak <1 )ixpeak=1;
    ilow=ixpeak-isigm;
    if(ilow <1 )ilow=1;
    ihih=ixpeak+isigm;
    if(ihih >nn)ihih=nn;
    m=ihih-ilow+1;
    ii=1;  cogd=cogn=0.;
    for(i=ilow;i<=ihih;i++){
      cogd+=ihist[i];
      cogn+=ihist[i]*i;
      temp=xnumb=0.;
      for(j=1;j<=nfilt;j++){
	jj=j-noff;
	if(i+jj < 1 || i+jj > nn)continue;
	temp+=ihist[i+jj]*buf[j];
	xnumb+=buf[j];
      }
      temp = (xnumb > 0.) ? temp/=xnumb : 0. ;
      if(temp < 1.)temp=1.;
      xpar[ii++]=log((double)temp);
    }
    parbol(xpar,m,&xp,&sd);
    xx=sd*sd-isigm*isigm;
    if(xx < 0.)xx=0.;
    fs=sqrt((double)xx);
    xp+=ilow-1;
    cog=(cogd > .5) ? cogn/cogd : xp;
    xx=xp-mode; if(xx <0.)xx=-xx;
    if(xx > gs)xp=cog;
  }
  mode--;
  xp=xp-1.0;
  xmean=xmean-1.0;
  xmed=xmed-1.0;
  if(xp > nn-gs)xp=xmed;
  if(xp < gs)xp=xmed;
  ixpeak=xp+1.5;
  icount=ihist[ixpeak];
  ilim=0.68*xcount+0.5;
  for(i=1;i<=nn;i++){
    ii=ixpeak+i;
    if(ii <= nn){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
    ii=ixpeak-i;
    if(ii >= 1){
      iwid++;
      icount+=ihist[ii];
      if(icount > ilim)break;
    }
  }
  gs=0.5*iwid;
  if(gs<fs)fs=gs;
  if(fs<1.)fs=1.;
  *xpeak=xp;
  *fsigma=fs;
}
